def lunar_addition(num1_str, num2_str):
    """Выполняет лунное сложение двух чисел."""

    max_len = max(len(num1_str), len(num2_str))
    num1_str = num1_str.zfill(max_len)
    num2_str = num2_str.zfill(max_len)

    result = ""
    for i in range(max_len):
        result += str(max(int(num1_str[i]), int(num2_str[i])))
    return result

def proiz(a, b):
    a = a[::-1]
    b = b[::-1]
    n = len(a)
    m = len(b)
    res2 = [0] * (n + m)

    for i in range(n):
        for j in range(m):
            prod = min(int(a[i]), int(b[j]))
            res2[i + j] = max(res2[i + j], prod)

    return "".join(map(str, res2[::-1])).lstrip("0") or "0"

if __name__ == "__main__":
    num1 = input()
    num2 = input()

    sum_result = lunar_addition(str(num1), str(num2))
    product_result = proiz(str(num1), str(num2))

    print(f"{sum_result} {product_result}")