import heapq


n, m, k = map(int, input().split())
points = []
for _ in range(m):
    u, v = map(int, input().split())
    points.append((u, v))
    points.append((v, u))

ohrana = []
for _ in range(k):
    p, h = map(int, input().split())
    ohrana.append((p, h))

adj = {i: [] for i in range(1, n + 1)}
for u, v in points:
    adj[u].append(v)

def dijkstra(start, max_d):
    s = {node: float('inf') for node in adj}
    s[start] = 0
    chered = [(0, start)]

    while chered:
        dist, current = heapq.heappop(chered)
        if dist > max_d:
            continue
        if dist > s[current]:
            continue

        for sosed in adj[current]:
            if s[sosed] > s[current] + 1:
                s[sosed] = s[current] + 1
                heapq.heappush(chered, (s[sosed], sosed))

    dostigaemoct = [node for node, dist in s.items() if dist <= max_d]
    return dostigaemoct

protect = set()
for ohranaset, ohranarun in ohrana:
    protect.update(dijkstra(ohranaset, ohranarun))

protect = sorted(list(protect))

print(len(protect))
if protect:
    print(*protect)

